/* 
   24/12/2011: aggiungo i messaggi in basso
               e risolvo i nuovi problemi...
   06/02/2010: modalità 16
   13/01/2010: cambiano i pezzi e il "mobiletto"
   13/12/2009: riordino del cOdice
               se il gioco è risolto si ferma per 2 secondi e poi aspetta il clic del mouse
*/

final int SHUFFLE = 300;
final int nRighe  = 4,  
          nColonne= 4,
          nULTIMA = nRighe*nColonne;
final int INIZIO  =-1,
          NUOVO   = 0,
          GIOCO   = 1,
          FINITO  = 2;
      int stato   = INIZIO;
final int modo15  = 0,
          modo14  = 1,
          modo16  = 2,
          modoPAL = 3;
      int MODO    = modo15;
final int dimR    = 42,
          dimC    = 42;
final int baseR   = 18,
          baseC   = 18;

final String MODI[]   ={"15", "14", "16", "pal"};
      String soluzione="RATEYOURMINDPAL";

int    RIGA[],  COLONNA[],
       ultimaR, ultimaC;        

PImage SFONDO;
String immagini;
PImage IMMAGINI[];
Blocco BLOCCHI[][];
PFont  font;

void setup()
{
    size(204,234);
    font=loadFont("DVSB18.vlw");
    textFont(font);    
    textAlign(CENTER);
    
    RIGA    =new int[nRighe];   for(int r=0; r<nRighe;   r++) RIGA[r]    =r*dimR+baseR;
    COLONNA =new int[nColonne]; for(int c=0; c<nColonne; c++) COLONNA[c] =c*dimC+baseC;

    BLOCCHI =new Blocco[nRighe][nColonne];

    String modo = param("mode");        
    if(modo != null)
    {
      for(int i=0; i < MODI.length; i++)
        if(modo.equals(MODI[i]))  
        {  
            MODO=i;  
            break;
        }
    }
    switch(MODO)
    {
      case modo15: immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne];   
                   for(int i=1; i < nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case modo14: immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne];   
                   for(int i=1; i < nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case modo16: immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne+1];   
                   for(int i=1; i <= nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case modoPAL:immagini="serie5"; 
                   IMMAGINI=new PImage[27];   
                   for(int i=1; i <= 26; i++)
                   {
                       char car=char(byte('a')+i-1);
                       IMMAGINI[i]=loadImage(immagini+"/"+car+".gif");  
                   }
                   break;
    }    
    SFONDO=loadImage(immagini+"/box.gif");
    
    int r, 
        c;    
    switch(MODO)
    {
      case modo15: r=0;
                   c=0;
                   for(int i=1; i<nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   ultimaR=nRighe-1;
                   ultimaC=nColonne-1;
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);  
                   break;
      case modo14: r=0;
                   c=1;
                   for(int i=1; i < nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   ultimaR=0;
                   ultimaC=0;
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);  
                   break;
      case modo16: r=0;
                   c=0;
                   for(int i=1; i <= nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   break;
      case modoPAL:String soluzione="RATEYOURMINDPAL";
                   r=0;
                   c=0;
                   for(int i=0; i < soluzione.length();  i++)
                   {
                       char car=soluzione.charAt(i);
                       int  x  =byte(car)-byte('A')+1;
                       BLOCCHI[r][c]=new Blocco(r, c, x, car);  
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                        
                   ultimaR=nRighe-1;
                   ultimaC=nColonne-1;
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0, ' ');  
                   break;
    }  
    stato=NUOVO;
}

void draw()
{
    background(0);
    image(SFONDO, 0, 0);
    
    for(int r=0; r<nRighe;   r++)
    for(int c=0; c<nColonne; c++)
        BLOCCHI[r][c].draw();

         if(stato==NUOVO)  { fill(0,255,0); text("Mescola!"  , 102, 224); }
    else if(stato==GIOCO)  { fill(255,0,0); text("Risolvi...", 102, 224); }
    else if(stato==FINITO) { fill(255    ); text("FINITO!!!" , 102+random(6)-3, 224); }
}
void controlla()
{
    int r=0,
        c=0;
    switch(MODO)
    {
      case modo15: for(int i=1; i<nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore != i)  
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   break;
      case modo14: for(int i=0; i<nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore != i) 
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   break;
      case modo16: for(int i=1; i<=nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore !=0 && BLOCCHI[r][c].valore != i)  
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, ultimaR*nColonne+ultimaC+1);
                   break;

      case modoPAL:for(int i=0; i<soluzione.length();  i++)
                   {
                       if(BLOCCHI[r][c].carattere != soluzione.charAt(i))
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   }
                   break;
    }  
    stato=FINITO;
}

void sposta(int nr, int nc)
{
    if
    (  
       nr == ultimaR && nc == ultimaC-1 && nc >= 0       ||
       nr == ultimaR && nc == ultimaC+1 && nc < nColonne ||
       nc == ultimaC && nr == ultimaR-1 && nr >= 0       ||
       nc == ultimaC && nr == ultimaR+1 && nr < nRighe   )
    {
       // scambia il valore dei blocchi adiacenti
       //      (nr, nc)
       // e 
       //      (ultimaR, ultimaC)
       int  x   = BLOCCHI[nr     ][nc     ].valore;
       char car = BLOCCHI[nr     ][nc     ].carattere;
                  BLOCCHI[nr     ][nc     ].valore   =0;                  
                  BLOCCHI[nr     ][nc     ].carattere=' ';
                  BLOCCHI[ultimaR][ultimaC].valore   =x;
                  BLOCCHI[ultimaR][ultimaC].carattere=car;
       ultimaR=nr;
       ultimaC=nc;
       
       if(stato==GIOCO)
           controlla();
    }
}

void mescola()
{
    if(MODO == modo16)
    {
      ultimaR=(int)random(nRighe);
      ultimaC=(int)random(nColonne);
      BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);  
    }  
  
    for(int i=1; i<=SHUFFLE; i++)                // più veloce???
    {
       switch(int(random(4)))
       {
          case 0: sposta(ultimaR+1, ultimaC  ); break;
          case 1: sposta(ultimaR-1, ultimaC  ); break;
          case 2: sposta(ultimaR  , ultimaC+1); break;
          case 3: sposta(ultimaR  , ultimaC-1); break;
       }
    }
}

void mousePressed()
{
    switch(stato)
    {
      case FINITO:   stato=NUOVO;
                     break;        
      case NUOVO:    mescola();
                     stato=GIOCO;
                     break;
        case GIOCO : int y=mouseY;  int riga   =(y-baseR)/dimR;   
                     int x=mouseX;  int colonna=(x-baseC)/dimC;                      
                     sposta(riga, colonna);        
                     break;
    }   
}

void keyPressed()
{
    switch(stato)
    {
       case NUOVO: break;       
       case FINITO:   break;              
       case GIOCO:    if(key==CODED)
                      {
                         int tasto=keyCode;
                         switch(tasto)
                         {
                            case UP:    sposta(ultimaR+1, ultimaC  ); break;
                            case DOWN:  sposta(ultimaR-1, ultimaC  ); break;
                            case LEFT:  sposta(ultimaR  , ultimaC+1); break;
                            case RIGHT: sposta(ultimaR  , ultimaC-1); break;
                         }
                      }
    }   
}

class Blocco
{
    int  riga;
    int  colonna; 
    int  valore;
    char carattere;

    Blocco(int r, int c, int x)
    {
      riga=r;
      colonna=c;
      valore=x;
    }
    Blocco(int r, int c, int x, char car)
    {
      riga=r;
      colonna=c;
      valore=x;
      carattere=car;
    }
    
    void draw()
    {
        if(valore != 0)  // ...
           image(IMMAGINI[valore], COLONNA[colonna], RIGA[riga]);
    }
}
